## lomiri-polkit-agent 0.1

=== CMakeLists.txt ===
cmake_minimum_required (VERSION 3.5)

project(lomiri-polkit-agent VERSION 0.1 LANGUAGES CXX)

set (PACKAGE_VERSION ${PROJECT_VERSION})
set (PACKAGE ${CMAKE_PROJECT_NAME})

##
## Directories
##

include (GNUInstallDirs)
if (EXISTS "/etc/debian_version") 
	set(CMAKE_INSTALL_LIBEXECDIR ${CMAKE_INSTALL_LIBDIR})
	set(CMAKE_INSTALL_FULL_LIBEXECDIR "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBEXECDIR}")
endif()

set(CMAKE_INSTALL_PKGLIBEXECDIR "${CMAKE_INSTALL_LIBEXECDIR}/${CMAKE_PROJECT_NAME}")
set(CMAKE_INSTALL_FULL_PKGLIBEXECDIR "${CMAKE_INSTALL_FULL_LIBEXECDIR}/${CMAKE_PROJECT_NAME}")
set(CMAKE_INSTALL_FULL_PKGDATADIR "${CMAKE_INSTALL_FULL_DATADIR}/${CMAKE_PROJECT_NAME}")

set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g -Wall -Werror -Wno-deprecated-declarations -std=c++14 -pthread ${GCOV_FLAGS}")

##
## Pkgconfig
##

find_package(PkgConfig REQUIRED)
pkg_check_modules(POLICYKIT REQUIRED polkit-agent-1)
pkg_check_modules(GIO REQUIRED gio-2.0)
pkg_check_modules(NOTIFY REQUIRED libnotify)

##
## Include code formatting
##

set_property(GLOBAL PROPERTY FORMAT_SOURCES)
find_package(FormatCode)

##
## Go deeper into the tree
##

add_subdirectory(service)
add_subdirectory(data)
add_subdirectory(po)

##
## Testing
##

option (enable_tests "Build the package's automatic tests." ON)

if (${enable_tests})
  enable_testing()
endif()

add_subdirectory(tests)

##
## Coverage
##

find_package(CoverageReport)
set(filter-list)
list(APPEND filter-list "/usr")
list(APPEND filter-list "${CMAKE_SOURCE_DIR}/tests")
list(APPEND filter-list "${CMAKE_SOURCE_DIR}/service/glib-thread.*")
if (NOT ${CMAKE_BINARY_DIR} STREQUAL ${CMAKE_SOURCE_DIR})
  list(APPEND filter-list "${CMAKE_BINARY_DIR}")
endif()

ENABLE_COVERAGE_REPORT(
  TARGETS service-lib policykit-agent
  TESTS agent-test authentication-test auth-manager-test
  FILTER ${filter-list}
)

##
## Do formatting
##

get_property(FORMAT_SOURCES_LOCAL GLOBAL PROPERTY FORMAT_SOURCES)
message(STATUS "Formatting sources: ${FORMAT_SOURCES_LOCAL}")
add_formatcode_target(${FORMAT_SOURCES_LOCAL} STYLE_NAME unity-api)
#add_formatcode_test(${FORMAT_SOURCES_LOCAL} STYLE_NAME unity-api)

=== service/CMakeLists.txt ===

include_directories(
	SYSTEM
	${POLICYKIT_INCLUDE_DIRS}
	${GIO_INCLUDE_DIRS}
	${NOTIFY_INCLUDE_DIRS}
)

add_definitions(-DPOLKIT_AGENT_I_KNOW_API_IS_SUBJECT_TO_CHANGE)

###################
# Library of Stuff
###################

set(LIBRARY_SOURCES
	agent.h
	agent.cpp
	agent-glib.h
	agent-glib.cpp
	auth-manager.h
	auth-manager.cpp
	authentication.h
	authentication.cpp
	glib-thread.h
	glib-thread.cpp
	session-iface.h
	session-iface.cpp
)

add_library(service-lib STATIC
	${LIBRARY_SOURCES}
)

target_link_libraries(service-lib
	${POLICYKIT_LIBRARIES}
	${GIO_LIBRARIES}
	${NOTIFY_LIBRARIES}
)

foreach(LIBSOURCE ${LIBRARY_SOURCES})
set_property(GLOBAL APPEND PROPERTY FORMAT_SOURCES "${CMAKE_CURRENT_SOURCE_DIR}/${LIBSOURCE}")
endforeach()

###################
# Service
###################

set(SERVICE_SOURCES
	main.cpp
)

add_executable(policykit-agent
	${SERVICE_SOURCES}
)
target_link_libraries(policykit-agent
	service-lib
)
install(TARGETS policykit-agent
	RUNTIME
	DESTINATION ${CMAKE_INSTALL_FULL_PKGLIBEXECDIR}
)

foreach(SERVICESRC ${SERVICE_SOURCES})
set_property(GLOBAL APPEND PROPERTY FORMAT_SOURCES "${CMAKE_CURRENT_SOURCE_DIR}/${SERVICESRC}")
endforeach()

=== debian/changelog ===
lomiri-polkit-agent (0.1-1build1) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 17:52:09 +1100

lomiri-polkit-agent (0.1-1) unstable; urgency=medium

  * Initial upload to Debian. (Closes: #1065663).

 -- Mike Gabriel <sunweaver@debian.org>  Fri, 08 Mar 2024 13:36:44 +0100

=== debian/control ===
Source: lomiri-polkit-agent
Section: x11
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian UBports Team <team+ubports@tracker.debian.org>
Uploaders: Mike Gabriel <sunweaver@debian.org>
Build-Depends: click-dev,
               cmake,
               cmake-extras,
               dbus,
               dbus-test-runner,
               debhelper-compat (= 13),
               debhelper,
               google-mock,
               libdbustest1-dev,
               libglib2.0-dev,
               libgtest-dev,
               libnotify-dev,
               libproperties-cpp-dev,
               libpolkit-agent-1-dev,
               python3-dbusmock,
Standards-Version: 4.6.2
Rules-Requires-Root: no
Homepage: https://gitlab.com/ubports/development/core/lomiri-polkit-agent
Vcs-Browser: https://gitlab.com/ubports/development/core/lomiri-polkit-agent/
Vcs-Git: https://gitlab.com/ubports/development/core/lomiri-polkit-agent.git

Package: lomiri-polkit-agent
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends},
Description: Service to prompt for policy kit permissions in Lomiri
 Connects to the Policy Kit daemon for the session and responds
 to requests for authentication. It then creates a Lomiri
 snap decision to request the password from the user, returning
 it back to PolicyKit.

=== debian/watch ===
version=4
https://gitlab.com/ubports/development/core/lomiri-polkit-agent/tags .*/lomiri-polkit-agent-(\d\S+)\.tar\.gz

## lomiri-polkit-agent 0.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,6 @@
 cmake_minimum_required (VERSION 3.5)
 
-project(lomiri-polkit-agent VERSION 0.1 LANGUAGES CXX)
+project(lomiri-polkit-agent VERSION 0.2 LANGUAGES CXX)
 
 set (PACKAGE_VERSION ${PROJECT_VERSION})
 set (PACKAGE ${CMAKE_PROJECT_NAME})
@@ -10,10 +10,6 @@
 ##
 
 include (GNUInstallDirs)
-if (EXISTS "/etc/debian_version") 
-	set(CMAKE_INSTALL_LIBEXECDIR ${CMAKE_INSTALL_LIBDIR})
-	set(CMAKE_INSTALL_FULL_LIBEXECDIR "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBEXECDIR}")
-endif()
 
 set(CMAKE_INSTALL_PKGLIBEXECDIR "${CMAKE_INSTALL_LIBEXECDIR}/${CMAKE_PROJECT_NAME}")
 set(CMAKE_INSTALL_FULL_PKGLIBEXECDIR "${CMAKE_INSTALL_FULL_LIBEXECDIR}/${CMAKE_PROJECT_NAME}")
@@ -29,6 +25,7 @@
 pkg_check_modules(POLICYKIT REQUIRED polkit-agent-1)
 pkg_check_modules(GIO REQUIRED gio-2.0)
 pkg_check_modules(NOTIFY REQUIRED libnotify)
+pkg_check_modules(PROPERTIESCPP REQUIRED properties-cpp)
 
 ##
 ## Include code formatting
@@ -49,13 +46,11 @@
 ## Testing
 ##
 
-option (enable_tests "Build the package's automatic tests." ON)
+include(CTest)
 
-if (${enable_tests})
-  enable_testing()
+if (BUILD_TESTING)
+  add_subdirectory(tests)
 endif()
-
-add_subdirectory(tests)
 
 ##
 ## Coverage

=== debian/changelog ===
lomiri-polkit-agent (0.2-1) unstable; urgency=medium

  * New upstream release.
    - Support API set_app_icon() change in libnotify 0.8.4. (Closes: #1098572).
  * debian/control:
    + Bump Standards-Version: to 4.7.2. No changes needed.
  * debian/patches:
    + Drop patches 1001, 1002, 1003. Applied upstream.
    + Drop 1004_fix-systemd-with-service-lomiri.patch . Unneeded now, issue
      resolved otherwise by upstream.
  * debian/copyright:
    + Update copyright attributions.

 -- Mike Gabriel <sunweaver@debian.org>  Wed, 12 Mar 2025 08:29:36 +0100

lomiri-polkit-agent (0.1-2) unstable; urgency=medium

  * debian/watch:
    + Update file for recent GitLab changes of the tags overview page.
  * debian/patches:
    + Add 1004_fix-systemd-with-service-lomiri.patch. Come-up with
      lomiri.service, as well (the service name is different in vanilla
      Debian/Ubuntu compared to Ubuntu Touch).
  * debian/control:
    + Bump Standards-Version to 4.7.0. No changes needed.

 -- Mike Gabriel <sunweaver@debian.org>  Sun, 25 Aug 2024 17:45:08 +0200

## lomiri-polkit-agent 0.3

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,6 @@
 cmake_minimum_required (VERSION 3.5)
 
-project(lomiri-polkit-agent VERSION 0.2 LANGUAGES CXX)
+project(lomiri-polkit-agent VERSION 0.3 LANGUAGES CXX)
 
 set (PACKAGE_VERSION ${PROJECT_VERSION})
 set (PACKAGE ${CMAKE_PROJECT_NAME})

=== debian/changelog ===
lomiri-polkit-agent (0.3-1) unstable; urgency=medium

  * New upstream release.

 -- Mike Gabriel <sunweaver@debian.org>  Wed, 19 Mar 2025 18:41:53 +0100

## lomiri-polkit-agent 0.3.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,6 @@
 cmake_minimum_required (VERSION 3.5)
 
-project(lomiri-polkit-agent VERSION 0.3 LANGUAGES CXX)
+project(lomiri-polkit-agent VERSION 0.3.1 LANGUAGES CXX)
 
 set (PACKAGE_VERSION ${PROJECT_VERSION})
 set (PACKAGE ${CMAKE_PROJECT_NAME})
@@ -15,7 +15,7 @@
 set(CMAKE_INSTALL_FULL_PKGLIBEXECDIR "${CMAKE_INSTALL_FULL_LIBEXECDIR}/${CMAKE_PROJECT_NAME}")
 set(CMAKE_INSTALL_FULL_PKGDATADIR "${CMAKE_INSTALL_FULL_DATADIR}/${CMAKE_PROJECT_NAME}")
 
-set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g -Wall -Werror -Wno-deprecated-declarations -std=c++14 -pthread ${GCOV_FLAGS}")
+set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g -Wall -Werror -Wno-deprecated-declarations -std=c++17 -pthread ${GCOV_FLAGS}")
 
 ##
 ## Pkgconfig

=== debian/changelog ===
lomiri-polkit-agent (0.3.1-1) unstable; urgency=medium

  * New upstream release.
    - Support building against GTest/GMock >= 1.17.0. (Closes: #1114190).

 -- Mike Gabriel <sunweaver@debian.org>  Sat, 06 Sep 2025 11:55:19 +0200

## lomiri-polkit-agent 0.3.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,6 @@
-cmake_minimum_required (VERSION 3.5)
+cmake_minimum_required (VERSION 3.10)
 
-project(lomiri-polkit-agent VERSION 0.3.1 LANGUAGES CXX)
+project(lomiri-polkit-agent VERSION 0.3.2 LANGUAGES CXX)
 
 set (PACKAGE_VERSION ${PROJECT_VERSION})
 set (PACKAGE ${CMAKE_PROJECT_NAME})

=== data/CMakeLists.txt ===

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/lomiri-polkit-agent.service.in
  ${CMAKE_CURRENT_BINARY_DIR}/lomiri-polkit-agent.service
  @ONLY
)

install(
  FILES ${CMAKE_CURRENT_BINARY_DIR}/lomiri-polkit-agent.service
  DESTINATION "${CMAKE_INSTALL_PREFIX}/lib/systemd/user"
)

=== service/CMakeLists.txt ===
--- 
+++ 
@@ -4,6 +4,7 @@
 	${POLICYKIT_INCLUDE_DIRS}
 	${GIO_INCLUDE_DIRS}
 	${NOTIFY_INCLUDE_DIRS}
+	${PROPERTIESCPP_INCLUDE_DIRS}
 )
 
 add_definitions(-DPOLKIT_AGENT_I_KNOW_API_IS_SUBJECT_TO_CHANGE)
@@ -30,6 +31,10 @@
 add_library(service-lib STATIC
 	${LIBRARY_SOURCES}
 )
+
+if (NOTIFY_VERSION VERSION_GREATER_EQUAL "0.8.4")
+    target_compile_definitions (service-lib PUBLIC LIBNOTIFY_HAS_SET_APP_ICON)
+endif ()
 
 target_link_libraries(service-lib
 	${POLICYKIT_LIBRARIES}

=== tests/CMakeLists.txt ===

include_directories("${CMAKE_SOURCE_DIR}/service")
include_directories(${GIO_INCLUDE_DIRS})
include_directories(${NOTIFY_INCLUDE_DIRS})

include_directories(${POLICYKIT_INCLUDE_DIRS})
add_definitions(-DPOLKIT_AGENT_I_KNOW_API_IS_SUBJECT_TO_CHANGE)

##############
# Google Test
##############

set (GTEST_SOURCE_DIR /usr/src/gtest/src)
set (GTEST_INCLUDE_DIR ${GTEST_SOURCE_DIR}/..)

find_package(GMock)

include_directories(${GTEST_INCLUDE_DIR})

##############
# DBus Test
##############

pkg_check_modules(DBUSTEST REQUIRED dbustest-1)
include_directories(${DBUSTEST_INCLUDE_DIRS})

##############
# PK Agent
##############

add_executable (agent-test
	agent-test.cpp
	polkit-lib-mock.cpp
)

target_link_libraries(agent-test
	${GMOCK_LIBRARIES}
	service-lib
	${DBUSTEST_LIBRARIES}
)

add_test (NAME agent-test
	COMMAND agent-test
)

set_property(GLOBAL APPEND PROPERTY FORMAT_SOURCES
	"${CMAKE_CURRENT_SOURCE_DIR}/agent-test.cpp"
	"${CMAKE_CURRENT_SOURCE_DIR}/polkit-lib-mock.cpp"
	"${CMAKE_CURRENT_SOURCE_DIR}/policykit-mock.h"
)

##############
# AuthManager
##############

add_executable (auth-manager-test
	auth-manager-test.cpp
)

target_link_libraries(auth-manager-test
	${GMOCK_LIBRARIES}
	service-lib
	${DBUSTEST_LIBRARIES}
)

add_test (NAME auth-manager-test
	COMMAND auth-manager-test
)

set_property(GLOBAL APPEND PROPERTY FORMAT_SOURCES "${CMAKE_CURRENT_SOURCE_DIR}/auth-manager-test.cpp")

##############
# Authentication
##############

add_executable (authentication-test
	authentication-test.cpp
)

target_link_libraries(authentication-test
	${GMOCK_LIBRARIES}
	service-lib
	${DBUSTEST_LIBRARIES}
)

add_test (NAME authentication-test
	COMMAND authentication-test
)

set_property(GLOBAL APPEND PROPERTY FORMAT_SOURCES "${CMAKE_CURRENT_SOURCE_DIR}/authentication-test.cpp")

=== debian/changelog ===
lomiri-polkit-agent (0.3.2-1) unstable; urgency=medium

  * New upstream release.
    - Support building with CMake >= 4. (Closes: #1113242).

 -- Mike Gabriel <sunweaver@debian.org>  Tue, 30 Sep 2025 20:29:15 +0200

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,7 @@
 Source: lomiri-polkit-agent
 Section: x11
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian UBports Team <team+ubports@tracker.debian.org>
+Maintainer: Debian UBports Team <team+ubports@tracker.debian.org>
 Uploaders: Mike Gabriel <sunweaver@debian.org>
 Build-Depends: click-dev,
                cmake,
@@ -19,7 +18,7 @@
                libproperties-cpp-dev,
                libpolkit-agent-1-dev,
                python3-dbusmock,
-Standards-Version: 4.6.2
+Standards-Version: 4.7.2
 Rules-Requires-Root: no
 Homepage: https://gitlab.com/ubports/development/core/lomiri-polkit-agent
 Vcs-Browser: https://gitlab.com/ubports/development/core/lomiri-polkit-agent/

=== debian/rules ===
#!/usr/bin/make -f

export DH_VERBOSE=1
export G_MESSAGES_DEBUG=all

include /usr/share/dpkg/default.mk

include /usr/share/dpkg/buildflags.mk
# see FEATURE AREAS in dpkg-buildflags(1)
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

override_dh_missing:
	dh_missing --fail-missing

override_dh_auto_configure:
	dh_auto_configure

get-orig-source:
	uscan --noconf --force-download --rename --download-current-version --destdir=..
